Unit IA03R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, IA02R_p, UTIA10_p;

procedure IA03R(var F :Array of Real; var T :Array of Real;
                var P :Array of Real; M :Integer; N :Integer;
                K1 :Integer; K2 :Integer; var IERR :Integer);

implementation

procedure IA03R(var F :Array of Real; var T :Array of Real;
                var P :Array of Real; M :Integer; N :Integer;
                K1 :Integer; K2 :Integer; var IERR :Integer);
var
K,L,KK1,KK2,KM,L1,L2,N1,NK,J :Integer;
FM,FK,SP,SF,S,RM,R :Real;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9;
begin
KK1 := Max0(1,K1);
KK2 := Min0(N,K2);
IERR := 0;
if ( KK1 <= KK2 ) 
 then goto _1;
IERR := 65;
goto _7;
_1:
if ( M = 0 ) 
 then goto _7;
N1 := 0;
RM := 0.0;
for L:=KK1 to KK2 do
 begin
  L1 := L+1;
  SP := 0.0;
  SF := 0.0;
  FM := F[L-1];
  for K:=1 to L do
   begin
    J := L1-K;
    SP := SP+P[J-1];
    SF := SF+F[J-1];
    FK := SF/SP;
    R := FK-FM;
    if ( M < 0 ) 
     then R := -R;
    if ( R > 0.0 ) 
     then goto _5;
_2:
   end;
  SP := 0.0;
  SF := 0.0;
  for K:=L to N do
   begin
    SP := SP+P[K-1];
    SF := SF+F[K-1];
    FK := SF/SP;
    R := FK-FM;
    if ( M < 0 ) 
     then R := -R;
    if ( R > 0.0 ) 
     then goto _5;
_3:
   end;
  N1 := N1+1;
  NK := L;
  L2 := N-L;
  IA02R(F,T,P,M,L);
  IA02R(F[L1-1],T[L1-1],P[L1-1],-M,L2);
  S := 0.0;
  for K:=1 to N do
   begin
_4:
    S := S+P[K-1]*T[K-1]*T[K-1];
   end;
  if ( S < RM ) 
   then goto _5;
  RM := S;
  KM := L;
_5:
 end;
if ( N1 > 0 ) 
 then goto _6;
IERR := 65;
goto _7;
_6:
if ( KM = NK ) 
 then goto _9;
IA02R(F,T,P,M,KM);
L1 := KM+1;
L2 := N-KM;
IA02R(F[L1-1],T[L1-1],P[L1-1],-M,L2);
goto _9;
_7:
for K:=1 to N do
 begin
_8:
  T[K-1] := F[K-1];
 end;
if ( IERR = 0 ) 
 then goto _9;
UTIA10(IERR,4);
_9:
end;

end.
